@echo off

if not exist "C:\Program Files (x86)\AviSynth 2.5\Uninstall.exe" GOTO Avisynth

rem mp4 Quality -------------------------------
set quality=24 
rem ( quality: 20-26 useful, smaler better quality ) 

set GOPSize=250
rem ( GOPSize: short clips needs smaler value, useful minimum 50 )  

set fps=
rem ( fps: frames per second )  
rem ---------------------------------------------

cd /d "%~dp1" 2>nul
cd /d %1 2>nul

set x1="%~1"
set x2="%cd%"

if "%~1"=="%CD%" GOTO folder
echo .............................
echo .
echo ....converting Video-File....
echo .
echo .............................

rem File Compression -------------------------------
if exist "%dat%_info.tmp" del "%dat%_info.tmp"
if exist "%~n1_tmp.avs" del "%~n1_tmp.avs"
if exist "%~n1_video.h264" del "%~n1_video.h264"
if exist "%~n1_audio.aac" del "%~n1_audio.aac"
if exist "%~n1_x264.mp4" del "%~n1_x264.mp4"

chcp 1252
if %~x1 == .avi (	
	@echo AVISource^( "%~1" ^).FlipVertical^(^) >> "%~n1_tmp.avs"
	set infile="%~n1_tmp.avs"
	) else (
		set infile="%~1"
		)
chcp 850

if not "%fps%" == "" GOTO vid
set dat=%date%_%time:~3,2%-%time:~6,2%
Z:\PROGRAMME\__GlobalTools\CMDTools\mediainfo --Inform="Video;%%FrameRate%%" %1 >> %dat%_info.tmp
for /f %%i in ( %dat%_info.tmp ) do set fps=%%i

:vid

Z:\PROGRAMME\__GlobalTools\CMDTools\avconv.exe -y -i %infile% -acodec aac -ab 160k -strict experimental -vn "%~n1_audio.aac"

Z:\PROGRAMME\__GlobalTools\CMDTools\avconv.exe -i %infile% -vcodec libx264 -crf %quality% -r %fps% -pix_fmt yuv420p -profile main -coder 1 -flags +loop+mv4 -cmp +chroma -partitions +parti8x8+parti4x4+partp8x8+partb8x8 -me_method umh -subq 8 -me_range 16 -g %GOPSize% -keyint_min 5 -sc_threshold 40 -i_qfactor 0.71 -b_strategy 2 -qcomp 0.6 -qmin 10 -qmax 51 -qdiff 4 -bf 3 -refs 4 -directpred 3 -trellis 1 -flags2 +wpred+mixed_refs+dct8x8+fastpskip -an -threads 0 -y "%~n1_video.h264"

Z:\PROGRAMME\__GlobalTools\CMDTools\mp4creator -create="%~n1_video.h264" -r %fps% "%~n1_x264.mp4"
Z:\PROGRAMME\__GlobalTools\CMDTools\mp4creator -create="%~n1_audio.aac" "%~n1_x264.mp4"

if exist "%dat%_info.tmp" del "%dat%_info.tmp"
if exist "%~n1_tmp.avs" del "%~n1_tmp.avs"
if exist "%~n1_video.h264" del "%~n1_video.h264"
if exist "%~n1_audio.aac" del "%~n1_audio.aac"

GOTO end
rem ---------------------------------------------------

rem Folder Compression -------------------------------

:folder

echo .............................
echo .
echo ..converting Frame-Sequence..
echo .
echo .............................

if not "%fps%" == "" GOTO comp
set fps=25

:comp

pushd %~1
setlocal enabledelayedexpansion
set number=0

for %%i in (*) do (
	set /a number=number+1
	set "file=%%i"
	)

set ext=%file:~-4%
call set name=%%file:%ext%=%%
set newname=%name:~0,-4%

if %ext% == .exr GOTO compEXR 
 
set endframe=%name:~-4%

set frame=%endframe:~0,-3%

if not %frame% == 0 GOTO 4digits

set frame0=%endframe:~-3%
set frame1=%endframe:~0,-2%

if not %frame1% == 00 GOTO 3digits
set frame2=%endframe:~-2%
set /a startframe=%frame2%-%number%+1

GOTO next

:3digits
set /a startframe=%frame0%-%number%+1

GOTO next

:4digits
set /a startframe=%endframe%-%number%+1

:next

popd

set "var=%newname%%%04d%ext%"

if exist "%~1\..\%~n1_tmp.avs" del "%~1\..\%~n1_tmp.avs"
if exist "%~1\..\%newname%_video.h264" del "%~1\..\%newname%_video.h264"
if exist "%~1\..\_%newname%_x264.mp4" del "%~1\..\_%newname%_x264.mp4"

echo ImageReader^( "%~1\%var%", start=%startframe%, end=%endframe%, fps=%fps% ^).FlipVertical^(^) >> "%~1\..\%~n1_tmp.avs"

Z:\PROGRAMME\__GlobalTools\CMDTools\avconv.exe -i "%~1\..\%~n1_tmp.avs" -vcodec libx264 -crf %quality% -profile main -pix_fmt yuv420p -coder 1 -flags +loop+mv4 -cmp +chroma -partitions +parti8x8+parti4x4+partp8x8+partb8x8 -me_method umh -subq 8 -me_range 16 -g %GOPSize% -keyint_min 5 -sc_threshold 40 -i_qfactor 0.71 -b_strategy 2 -qcomp 0.6 -qmin 10 -qmax 51 -qdiff 4 -bf 3 -refs 4 -directpred 3 -trellis 1 -flags2 +wpred+mixed_refs+dct8x8+fastpskip -an -threads 0 -y "%~1\..\%newname%_video.h264"

Z:\PROGRAMME\__GlobalTools\CMDTools\mp4creator -create="%~1\..\%newname%_video.h264" -r %fps% "%~1\..\_%newname%_x264.mp4"

if exist "%~1\..\%~n1_tmp.avs" del "%~1\..\%~n1_tmp.avs"
if exist "%~1\..\%newname%_video.h264" del "%~1\..\%newname%_video.h264"

GOTO end

:compEXR
set /P gamma="Set Gamma Value:"
rem ( gamma: gamma correction ) 

pushd %~1

if exist TMPframe* del TMPframe*
if exist *_tmp.png del *_tmp.png

for %%i in (*.exr) do ( 
	Z:\PROGRAMME\__GlobalTools\CMDTools\imf_copy.exe -v -g %gamma% "%%i" "%%~ni_tmp.png" png rgba
	) 

setlocal enabledelayedexpansion
set number=0
for %%i in (*_tmp.png) do (
	set /a number=number+1
	set "number1=000!number!"
	set "number2=!number1:~-4!"
	
	ren "%%i" "TMPframe_!number2!.png"
	)

if exist "%~1\..\%newname%_video.h264" del "%~1\..\%newname%_video.h264"
if exist "%~1\..\_%newname%_x264.mp4" del "%~1\..\_%newname%_x264.mp4"

Z:\PROGRAMME\__GlobalTools\CMDTools\avconv.exe -i "TMPframe_%%04d.png" -vcodec libx264 -crf %quality% -r %fps% -pix_fmt yuv420p -profile main -coder 1 -flags +loop+mv4 -cmp +chroma -partitions +parti8x8+parti4x4+partp8x8+partb8x8 -me_method umh -subq 8 -me_range 16 -g %GOPSize% -keyint_min 5 -sc_threshold 40 -i_qfactor 0.71 -b_strategy 2 -qcomp 0.6 -qmin 10 -qmax 51 -qdiff 4 -bf 3 -refs 4 -directpred 3 -trellis 1 -flags2 +wpred+mixed_refs+dct8x8+fastpskip -an -threads 0 -y "%~1\..\%newname%_video.h264"

Z:\PROGRAMME\__GlobalTools\CMDTools\mp4creator -create="%~1\..\%newname%_video.h264" -r %fps% "%~1\..\_%newname%_x264.mp4"

if exist TMPframe* del TMPframe*
if exist "%~1\..\%newname%_video.h264" del "%~1\..\%newname%_video.h264"

endlocal
popd

GOTO end
rem -------------------------------------------

:Avisynth

echo -------------------------------
echo - Bitte Avisynth installieren -
echo .
echo - druecke Key zum fortfahren --
echo -------------------------------

pause
"Z:\PROGRAMME\__GlobalTools\CMDTools\Avisynth_258.exe"
exit

:end
echo .
echo .
echo .
echo ..........converting done............
echo .
echo .
pause
